
//---- inclusion de librairie
#include <Servo.h> // inclut la librairie Servo

//--- entete déclarative = variables et constantes globales 
int octetReception=0; // variable de réception octet
long nombreReception=0; // déclare variable long stocker nombre recu

const int brocheServo3=3; // broche du servomoteur 
const int brocheServo5=5;
const int brocheServo7=7;
const int brocheServo9=9;
const int brocheServo11=11;
const int brocheServo13=13;
const int cap1=A0;
const int cap2=A1;
const int cap3=A2;
const int cap4=A3;
const int cap5=A4;





Servo servo1; // déclaration d'un objet servomoteur


void setup() {//--- la fonction setup() : exécutée au début et 1 seule fois

   Serial.begin(115200); // initialise la vitesse de la connexion série
   //-- utilise la meme vitesse dans le Terminal Série
   
pinMode(brocheServo3,OUTPUT);
pinMode(brocheServo5,OUTPUT);
pinMode(brocheServo7,OUTPUT);
pinMode(brocheServo9,OUTPUT);
pinMode(brocheServo11,OUTPUT);
pinMode(brocheServo13,OUTPUT);


   servo1.attach(brocheServo5); // attache le servomoteur à la broche
   
  Serial.println ("******** Etalonnage servomoteur ******* "); 

   Serial.println ("Verifier que option <nouvelle ligne> est active."); 
   Serial.println ("Saisir valeur entre 500 et 2500 microsecondes"); 
   
} // fin de la fonction setup()

void loop() { //--- la fonction loop() : exécutée en boucle sans fin 

  while (Serial.available()>0) { // si un caractère en réception
    
    octetReception=Serial.read(); // lit le 1er octet de la file d'attente    

    if (octetReception==10) { // si Octet reçu est le saut de ligne 
          Serial.print ("Saut de ligne recu : ");          
          Serial.print ("Nombre recu = "); // affiche la le nombre reçu
          Serial.println (nombreReception); 

         servo1.writeMicroseconds(nombreReception);
         Serial.print ("Largeur impulsion servomoteur = "); 
         Serial.print (nombreReception); 
         Serial.println (" microsecondes"); 
          
          
          nombreReception=0; //RAZ le String de réception
          delay(10); // pause
          break; // sort de la boucle while
    } // fin if 
    
    else { // si le caractère reçu n'est pas un saut de ligne        

          octetReception=octetReception-48; // transfo valeur ASCII en valeur décimale
          
                   // calcul du nombre à partir des valeurs reçues  
          if ((octetReception>=0)&&(octetReception<=9)) nombreReception = (nombreReception*10)+octetReception; 
          else Serial.println("La chaine n'est pas un nombre valide !"); 
          
          delay(1); // laisse le temps au caractères d'arriver
          
    } // fin else 

    
  } // fin while - fin de réception de la chaine



} // fin de la fonction loop()


